//-----------------------------------------
// tre compatible avec MSIE...
//-----------------------------------------

if ('undefined' == typeof Node)
    Node = { ELEMENT_NODE: 1, TEXT_NODE: 3 };

function addListener(element, baseName, handler) {
    if (element.addEventListener)
        element.addEventListener(baseName, handler, false);
    else if (element.attachEvent)
        element.attachEvent('on' + baseName, handler);
} // addListener

function stopEvent(e) {
    if (e.stopPropagation) {
        e.stopPropagation();
        e.preventDefault();
    } else {
        e.cancelBubble = true;
        e.returnValue = false;
    }
} // stopEvent

//------------------------------------------------------
// Decoration de labels en fonction de l'accesskey
//------------------------------------------------------
function decorateLabels() {
	var labels = document.getElementsByTagName('label');
    for (var index = 0; index < labels.length; ++index) {
        var label = labels[index];
        if (label.accessKey) {
            var ak = label.accessKey.toUpperCase();
            decorateNodeForAccessKey(label, ak);
        }
        if (label.htmlFor) {
            var elt = document.getElementById(label.htmlFor);
            if (!elt)
                continue;
            if (elt.id.match(/Req/))
                label.className += ' required';
        }
    }
} // decorateLabels

function decorateNodeForAccessKey(elt, key) {
    if (Node.ELEMENT_NODE == elt.nodeType) {
        var node = elt.firstChild;
        while (node && !decorateNodeForAccessKey(node, key))
            node = node.nextSibling;
        // Si node n'est pas null, on a trouv l'AK dans un descendant
        // et on a dcor : on renvoie non-null, donc quivalent true
        return node;
    }
    if (Node.TEXT_NODE != elt.nodeType)
        return false;
    var pos = elt.nodeValue.toUpperCase().indexOf(key);
    if (-1 == pos)
        return false;
    var suffix = elt.nodeValue.substring(pos + 1);
    var akSpan = document.createElement('span');
    akSpan.className = 'accessKey';
    akSpan.appendChild(document.createTextNode(elt.nodeValue.charAt(pos)));
    // On vite node.splitText et node.deleteData sur MSIE...  On manipule
    // nodeValue et on cre le deuxime noeud Texte manuellement.
    elt.nodeValue = elt.nodeValue.substring(0, pos);
    elt.parentNode.appendChild(akSpan);
    elt.parentNode.appendChild(document.createTextNode(suffix));
    // Trs important pour viter une rcursion infinie !
    return true;
} // decorateNodeForAccessKey


//------------------------------------------------------
// Limiteur de caracteres dans les textAreas (JL)
//------------------------------------------------------
function attachTextAreaLimiter(textArea, charCount)
{
	// On cree l'lment qui va servir pour afficher le nombre de caracteres restants
	var leftSpan = document.createElement('span');
	leftSpan.className = "textAreaLeft";
	leftSpan.appendChild(document.createTextNode(charCount));
	textArea.parentNode.appendChild(leftSpan);
	textArea.leftSpan=leftSpan;
	textArea.charCount=charCount;
	
	// On place les handler sur le textArea
	addListener(textArea, 'DOMFocusOut', 	textAreaHasChanged );
	addListener(textArea, 'click', 			textAreaHasChanged );
	addListener(textArea, 'keyup', 			textAreaHasChanged );
	addListener(textArea, 'keydown', 		textAreaHasChanged );
	
	var fakeEvent = { target:textArea }
	textAreaHasChanged(fakeEvent);

}

function textAreaHasChanged(e)
{
	e = e || window.event;
	var textArea = e.target || e.srcElement;
	
	var textLength = textArea.value.length;
	
	// On clip 
	if (textLength > textArea.charCount)
		textArea.value = textArea.value.substr(0, textArea.charCount); 
		
	// On met  jour le nombre de char restant
	textArea.leftSpan.firstChild.nodeValue='('+(textArea.charCount-textArea.value.length)+')';
}

REGEX_LIMITED_TEXTAREA = /^[^_]+_+([0-9]+)$/;
function attachTextAreaLimiters()
{
	// On cherche tous les textArea dont on veut limiter la taille
	var textAreas = document.getElementsByTagName('textarea');
	for (var index = 0; index < textAreas.length; ++index)
	{
		var textArea = textAreas[index];
		var match = textArea.id.match(REGEX_LIMITED_TEXTAREA);
		if (!match)
			continue;
		attachTextAreaLimiter(textArea, match[1]);
	}
}

//-----------------------------------------------------------------------
// Ouverture de lien dans un nouvel onglet / fenetre (ALSACREATIONS
//-----------------------------------------------------------------------
function attachExternalLinks()
{
	var liens = document.getElementsByTagName('a');
	// On rcupre tous les liens (<a>) du document dans une variable (un array), ici liens.
	// Une boucle qui parcourt le tableau (array) liens du dbut  la fin.
	for (var i = 0 ; i < liens.length ; ++i)  {
		// Si les liens ont un nom de class gal  lien_ext, alors on agit.
		if (liens[i].className == 'lien_ext')  {
			//liens[i].title = 'S\'ouvre dans une nouvelle fentre';
			// Au clique de la souris.
			liens[i].onclick = function()  {
				window.open(this.href);
				return false; // On ouvre une nouvelle page ayant pour URL le href du lien cliqu et on inhibe le lien rel.
			};
		}
	}
}

